using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;

namespace SummaryRowSample
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridControl gridControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridControl1
			// 
			this.gridControl1.AllowDragSelectedCols = true;
			this.gridControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridControl1.Location = new System.Drawing.Point(16, 40);
			this.gridControl1.Name = "gridControl1";
			this.gridControl1.RowCount = 20;
			this.gridControl1.Size = new System.Drawing.Size(412, 225);
			this.gridControl1.SmartSizeBox = false;
			this.gridControl1.TabIndex = 0;
			this.gridControl1.Text = "gridControl1";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(448, 278);
			this.Controls.Add(this.gridControl1);
			this.Name = "Form1";
			this.Text = "Adding a Summary to GridControl";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		
		

		private GridSummaryRow sumRow;

		private void Form1_Load(object sender, System.EventArgs e)
		{
			//set a style on a column...
			this.gridControl1.ColStyles[2].BackColor = Color.LightGoldenrodYellow;

			//populate the grid
			PopulateGrid();

			//create a summary row...
			sumRow = new GridSummaryRow();
			//define the summary type for each column
			object[] summaryTypes = new object[this.gridControl1.ColCount];
			for(int i = 0; i < this.gridControl1.ColCount; ++i)
			{
				if( i == 1 || i == 3 ) //sum these
				{
					summaryTypes[i] = GridSummaryRow.SummaryType.Sum;
				}
				else if(i == 4) //do max
				{
					summaryTypes[i] = new GridSummaryRow.CustomSummaryCalculation(calc_Max);
				}
				else if(i == 5) //do min
				{
					summaryTypes[i] = new GridSummaryRow.CustomSummaryCalculation(calc_Min);
				}
				else //no summary
					summaryTypes[i] = GridSummaryRow.SummaryType.None;
			}

			//two ways to wire the summary row

			//1) use default table style
			//sumRow.WireSummaryRow(this.gridControl1, summaryTypes);

			//2) or set each column style somehow....
			GridStyleInfo[] styles = new GridStyleInfo[this.gridControl1.ColCount];
			for(int i = 0; i < this.gridControl1.ColCount; ++i)
			{
				styles[i] = new GridStyleInfo((GridStyleInfoStore)this.gridControl1.ColStyles[i+1].Store.Clone());
				styles[i].Font.Bold = true;
			}
			sumRow.WireSummaryRow(this.gridControl1, summaryTypes, styles);

			//padd the grid's client area with empty rows
			this.gridControl1.Model.Options.DisplayEmptyRows = true;
		}

		//custom calculation
		private object calc_Max()
		{
			GridCurrentCell cc = this.gridControl1.CurrentCell;
			
			int col = 5; // i + 1
			double d = double.Parse(this.gridControl1[1, col].Text);
			for(int row = 2; row <= this.gridControl1.RowCount; ++row)
			{
				string s = (cc.HasCurrentCellAt(row, col) && cc.IsEditing)
					? cc.Renderer.ControlText : this.gridControl1[row, col].Text;
				d = Math.Max(d, double.Parse(s));
			}
			return d;
		}

		//custom calculation
		private object calc_Min()
		{
			GridCurrentCell cc = this.gridControl1.CurrentCell;
			int col = 6; // i + 1
			double d = double.Parse(this.gridControl1[1, col].Text);
			for(int row = 2; row <= this.gridControl1.RowCount; ++row)
			{
				string s = (cc.HasCurrentCellAt(row, col) && cc.IsEditing)
					? cc.Renderer.ControlText : this.gridControl1[row, col].Text;
				d = Math.Min(d, double.Parse(s));
			}

			return d;
		}

		//put some data in the grid
		private void PopulateGrid()
		{
			Random r = new Random();
			GridData data = this.gridControl1.Data;
			for(int row = 1; row <= this.gridControl1.RowCount; row++)
			{
				for(int col = 1; col <= this.gridControl1.ColCount; ++col)
				{
					GridStyleInfo style = new GridStyleInfo();
					style.CellValue = r.Next(100);
					data[row, col] = style.Store;
				}

			}
		}
	}
}
