using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;


namespace SummaryRowSample
{
	/// <summary>
	/// Summary description for Form3.
	/// </summary>
	public class Form3 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form3()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.gridDataBoundGrid1.GridCapture = false;
			this.gridDataBoundGrid1.HScrollPixel = false;
			this.gridDataBoundGrid1.IsWindowless = false;
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(16, 16);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.ParentSite = null;
			this.gridDataBoundGrid1.PrintBounds = new System.Drawing.Rectangle(0, 0, 0, 0);
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(400, 244);
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 0;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			// 
			// Form3
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(432, 270);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.gridDataBoundGrid1});
			this.Name = "Form3";
			this.Text = "Adding a Summary to GridDataboundGrid";
			this.Load += new System.EventHandler(this.Form3_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion


		private GridSummaryRow sumRow;

		private void Form3_Load(object sender, System.EventArgs e)
		{
			this.gridDataBoundGrid1.DataSource = GetTable("table", 8, 20);
		

			//create a summary row...
			sumRow = new GridSummaryRow();
			//define the summary type for each column
			object[] summaryTypes = new object[this.gridDataBoundGrid1.Model.ColCount];
			for(int i = 0; i < this.gridDataBoundGrid1.Model.ColCount; ++i)
			{
				if( i == 1 || i == 3 ) //sum these
				{
					summaryTypes[i] = GridSummaryRow.SummaryType.Sum;
				}
				else if(i == 4) //do max
				{
					summaryTypes[i] = new GridSummaryRow.CustomSummaryCalculation(calc_Max);
				}
				else if(i == 5) //do min
				{
					summaryTypes[i] = new GridSummaryRow.CustomSummaryCalculation(calc_Min);
				}
				else //no summary
					summaryTypes[i] = GridSummaryRow.SummaryType.None;
			}

			//two ways to wire the summary row

			//1) use default table style
			//sumRow.WireSummaryRow(this.gridDataBoundGrid1, summaryTypes);

			//2) or set each column style somehow....
			GridStyleInfo[] styles = new GridStyleInfo[this.gridDataBoundGrid1.Model.ColCount];
			for(int i = 0; i < this.gridDataBoundGrid1.Model.ColCount; ++i)
			{
				styles[i] = new GridStyleInfo((GridStyleInfoStore)this.gridDataBoundGrid1.Binder.InternalColumns[i].StyleInfo.Store.Clone());
				styles[i].Font.Bold = true;
			}
			sumRow.WireSummaryRow(this.gridDataBoundGrid1, summaryTypes, styles);

			//this.gridDataBoundGrid1.EnableAddNew = false;

			//padd the grid's client area with empty rows
			this.gridDataBoundGrid1.Model.Options.DisplayEmptyRows = true;
		}

		//custom calculation
		private object calc_Max()
		{
			GridCurrentCell cc = this.gridDataBoundGrid1.CurrentCell;
			
			int col = 5; // i + 1
			double d = double.Parse(this.gridDataBoundGrid1[1, col].Text);
			for(int row = 2; row <= this.gridDataBoundGrid1.Model.RowCount; ++row)
			{
				string s = (cc.HasCurrentCellAt(row, col) && cc.IsEditing)
					? cc.Renderer.ControlText : this.gridDataBoundGrid1[row, col].Text;
				if(s.Length == 0)
					s = int.MinValue.ToString();
				d = Math.Max(d, double.Parse(s));
			}
			return d;
		}

		//custom calculation
		private object calc_Min()
		{
			GridCurrentCell cc = this.gridDataBoundGrid1.CurrentCell;
			int col = 6; // i + 1
			double d = double.Parse(this.gridDataBoundGrid1[1, col].Text);
			for(int row = 2; row <= this.gridDataBoundGrid1.Model.RowCount; ++row)
			{
				string s = (cc.HasCurrentCellAt(row, col) && cc.IsEditing)
					? cc.Renderer.ControlText : this.gridDataBoundGrid1[row, col].Text;
				if(s.Length == 0)
					s = int.MaxValue.ToString();
				
				d = Math.Min(d, double.Parse(s));
			}

			return d;
		}

		private DataTable GetTable(string name, int nCols, int nRows)
		{
			DataTable dt = new DataTable(name);
			for(int i = 0; i < nCols; i++)
				dt.Columns.Add(new DataColumn(string.Format("Col{0}", i), typeof(int)));

			Random r = new Random();

			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				for(int j = 0; j < nCols; j++)
				{
					dr[j] = (int) r.Next(100);
				}
				dt.Rows.Add(dr);
			}
			return dt;
		}

	}
}
