
Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.Data
Imports Syncfusion.Windows.Forms.Grid


 
Public Class Form1
   Inherits System.Windows.Forms.Form
   Private gridControl1 As Syncfusion.Windows.Forms.Grid.GridControl

   Private components As System.ComponentModel.Container = Nothing
   
   
   Public Sub New()
      '
      ' Required for Windows Form Designer support
      '
      InitializeComponent()
   End Sub 'New
    
    
   
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub 'Dispose

#Region "Windows Form Designer generated code"

    '/ <summary>
    '/ Required method for Designer support - do not modify
    '/ the contents of this method with the code editor.
    '/ </summary>
    Private Sub InitializeComponent()
        Me.gridControl1 = New Syncfusion.Windows.Forms.Grid.GridControl
        CType(Me.gridControl1, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'gridControl1
        '
        Me.gridControl1.AllowDragSelectedCols = True
        Me.gridControl1.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
        Me.gridControl1.Location = New System.Drawing.Point(16, 40)
        Me.gridControl1.Name = "gridControl1"
        Me.gridControl1.RowCount = 20
        Me.gridControl1.Size = New System.Drawing.Size(412, 225)
        Me.gridControl1.SmartSizeBox = False
        Me.gridControl1.TabIndex = 0
        Me.gridControl1.Text = "gridControl1"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(448, 278)
        Me.Controls.Add(Me.gridControl1)
        Me.Name = "Form1"
        Me.Text = "Adding a Summary to GridControl"
        CType(Me.gridControl1, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub 'InitializeComponent 
#End Region



   

    Private sumRow As GridSummaryRow


    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'set a style on a column...
        Me.gridControl1.ColStyles(2).BackColor = Color.LightGoldenrodYellow

        'populate the grid
        PopulateGrid()

        'create a summary row...
        sumRow = New GridSummaryRow
        'define the summary type for each column
        Dim summaryTypes(Me.gridControl1.ColCount) As Object
        Dim i As Integer

        While i < Me.gridControl1.ColCount
            If i = 1 OrElse i = 3 Then 'sum these
                summaryTypes(i) = GridSummaryRow.SummaryType.Sum
            ElseIf i = 4 Then 'do max
                summaryTypes(i) = New SummaryRowSample.GridSummaryRow.CustomSummaryCalculation(AddressOf calc_Max)
            ElseIf i = 5 Then 'do min
                summaryTypes(i) = New SummaryRowSample.GridSummaryRow.CustomSummaryCalculation(AddressOf calc_Min)
                'no summary
            Else
                summaryTypes(i) = GridSummaryRow.SummaryType.None
            End If
            i += 1
        End While

        'two ways to wire the summary row
        '1) use default table style
        'sumRow.WireSummaryRow(this.gridControl1, summaryTypes);
        '2) or set each column style somehow....
        Dim styles(Me.gridControl1.ColCount) As GridStyleInfo
        For i = 0 To Me.gridControl1.ColCount - 1
            styles(i) = New GridStyleInfo(CType(Me.gridControl1.ColStyles((i + 1)).Store.Clone(), GridStyleInfoStore))
            styles(i).Font.Bold = True
        Next i
        sumRow.WireSummaryRow(Me.gridControl1, summaryTypes, styles)

        'padd the grid's client area with empty rows
        Me.gridControl1.Model.Options.DisplayEmptyRows = True
    End Sub 'Form1_Load


    'custom calculation
    Private Function calc_Max() As Object
        Dim cc As GridCurrentCell = Me.gridControl1.CurrentCell

        Dim col As Integer = 5 ' i + 1
        Dim d As Double = Double.Parse(Me.gridControl1(1, col).Text)
        Dim row As Integer = 2

        While row <= Me.gridControl1.RowCount
            Dim s As String
            If (cc.HasCurrentCellAt(row, col) AndAlso cc.IsEditing) Then
                s = cc.Renderer.ControlText
            Else
                s = Me.gridControl1(row, col).Text
            End If
            If s.Length = 0 Then s = Integer.MinValue.ToString()
            d = Math.Max(d, Double.Parse(s))
            row += 1
        End While
        Return d
    End Function 'calc_Max


    'custom calculation
    Private Function calc_Min() As Object
        Dim cc As GridCurrentCell = Me.gridControl1.CurrentCell
        Dim col As Integer = 6 ' i + 1
        Dim d As Double = Double.Parse(Me.gridControl1(1, col).Text)
        Dim row As Integer = 2

        While row <= Me.gridControl1.RowCount
            Dim s As String
            If (cc.HasCurrentCellAt(row, col) AndAlso cc.IsEditing) Then
                s = cc.Renderer.ControlText
            Else
                s = Me.gridControl1(row, col).Text
            End If
            If s.Length = 0 Then s = Integer.MaxValue.ToString()
            d = Math.Min(d, Double.Parse(s))
            row += 1
        End While

        Return d
    End Function 'calc_Min


    'put some data in the grid
    Private Sub PopulateGrid()
        Dim r As New Random
        Dim data As GridData = Me.gridControl1.Data
        Dim row As Integer
        For row = 1 To Me.gridControl1.RowCount
            Dim col As Integer = 0

            While col <= Me.gridControl1.ColCount
                Dim style As New GridStyleInfo
                style.CellValue = r.Next(100)
                data(row, col) = style.Store
                col += 1
            End While
        Next row
    End Sub 'PopulateGrid
End Class 'Form1
